## ros-dashing-realsense-ros2-camera 2.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(realsense_ros2_camera)

# ROS2 Flags
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# Compiler Defense Flags
if(UNIX OR APPLE)
  # Linker flags.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    # GCC specific flags. ICC is compatible with them.
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z noexecstack -z relro -z now")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z noexecstack -z relro -z now")
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    # In Clang, -z flags are not compatible, they need to be passed to linker via -Wl.
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
  endif()

  # Compiler flags.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    # GCC specific flags.
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.9 OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.9)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector-strong")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector")
    endif()
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    # Clang is compatbile with some of the flags.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector")
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    # Same as above, with exception that ICC compilation crashes with -fPIE option, even
    # though it uses -pie linker option that require -fPIE during compilation. Checksec
    # shows that it generates correct PIE anyway if only -pie is provided.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector")
  endif()

  # Generic flags.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -fno-operator-names -Wformat -Wformat-security -Wall")
  # Dot not forward c++ flag to GPU beucause it is not supported
  set( CUDA_PROPAGATE_HOST_FLAGS OFF )
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -D_FORTIFY_SOURCE=2")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
endif()

find_package(librealsense2)
if(NOT librealsense2_FOUND)
  message(FATAL_ERROR "\n\n Intel RealSense SDK 2.0 is missing, please install it from https://github.com/IntelRealSense/librealsense/releases\n\n")
endif()

if(CMAKE_BUILD_TYPE EQUAL "RELEASE")
  message(STATUS "Create Release Build.")
  set(CMAKE_CXX_FLAGS "-O2 ${CMAKE_CXX_FLAGS}")
else()
  message(STATUS "Create Debug Build.")
endif()

set(CMAKE_CXX_FLAGS "-fPIE -fPIC -D_FORTIFY_SOURCE=2 -fstack-protector -Wformat -Wformat-security -Wall ${CMAKE_CXX_FLAGS}")

find_package(ament_cmake REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(builtin_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rmw_implementation REQUIRED)
find_package(std_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(tf2 REQUIRED)
find_package(realsense_camera_msgs REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(OpenCV REQUIRED)
find_package(image_transport REQUIRED)

include_directories(
  include
  ${rclcpp_INCLUDE_DIRS}
  ${rmw_implementation_INCLUDE_DIRS}
  ${std_msgs_INCLUDE_DIRS}
  ${sensor_msgs_INCLUDE_DIRS}
  ${cv_bridge_INCLUDE_DIRS}
  ${tf2_ros_INCLUDE_DIRS}
  ${tf2_INCLUDE_DIRS}
  ${librealsense2_INCLUDE_DIRS}
)

add_executable(${PROJECT_NAME}
  include/${PROJECT_NAME}/constants.hpp
  src/realsense_camera_node.cpp
)

target_link_libraries(${PROJECT_NAME}
  ${rclcpp_LIBRARIES}
  ${rmw_implementation_LIBRARIES}
  ${std_msgs_LIBRARIES}
  ${sensor_msgs_LIBRARIES}
  ${tf2_ros_LIBRARIES}
  ${tf2_LIBRARIES}
  ${realsense_camera_msgs_LIBRARIES}
  ${cv_bridge_LIBRARIES}
  ${librealsense2_LIBRARIES}
)
ament_target_dependencies(${PROJECT_NAME}
  rclcpp
  rmw_implementation
  std_msgs
  sensor_msgs
  tf2_ros
  tf2
  realsense_camera_msgs
  cv_bridge
  OpenCV
  image_transport
  librealsense2
)

# Install binaries
install(TARGETS ${PROJECT_NAME}
  RUNTIME DESTINATION bin
)

install(TARGETS ${PROJECT_NAME}
  DESTINATION lib/${PROJECT_NAME}
)

# Install header files
install(
  DIRECTORY include/
  DESTINATION include
)

# Install launch files.
install(DIRECTORY
  launch
  DESTINATION share/${PROJECT_NAME}/
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  set(REALSENSE_DEVICE_PLUGIN FALSE)
  if(${REALSENSE_DEVICE_PLUGIN})
    ament_add_gtest(test_api test/test_api.cpp)
  endif()
  if(TARGET test_api)
    target_include_directories(test_api PUBLIC
      ${${PROJECT_NAME}_INCLUDE_DIRS}
    )
    ament_target_dependencies(test_api
      rclcpp
      sensor_msgs
      tf2_ros
      tf2
      OpenCV)
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-dashing-realsense-ros2-camera (2.0.4-2bionic) bionic; urgency=high

  * Merge pull request #50 <https://github.com/intel/ros2_intel_realsense/issues/50> from ahuizxc/dashing
    fix compiling failure after ros2 core updated and remove some warnings.
  * fix compiling failure after ros2 core updated and remove some warnings.
  * Merge pull request #44 <https://github.com/intel/ros2_intel_realsense/issues/44> from ahuizxc/master
    add depthimage to laser scan launch file
  * add depthimage to laser scan
  * enable librealsensev2.17.1
    enable librealsensev2.17.1
  * update package.xml and readme
  * enable librealsensev2.17.1
  * Merge pull request #39 <https://github.com/intel/ros2_intel_realsense/issues/39> from challen-zhou/master
    Add options to enable/disable color-aligned point cloud
  * Change aligned pointcloud format from XYZ to XYZRGB
  * Add options to enable/disable color-aligned point cloud
    Since the default 2 point cloud process cost too much computation,
    add option to enable/disable(default) color-aligned point cloud.
  * Merge pull request #36 <https://github.com/intel/ros2_intel_realsense/issues/36> from challen-zhou/master
    Add pointcloud aligned with color
  * Add pointcloud aligned with color
    Add pointcloud generate from depth which aligned to color,
    no RGB channel since this pointcloud one-to-one matches with color image.
  * Merge pull request #32 <https://github.com/intel/ros2_intel_realsense/issues/32> from challen-zhou/master
    Update depth alignment function to align with librealsense
  * Merge pull request #30 <https://github.com/intel/ros2_intel_realsense/issues/30> from ahuizxc/master
    pass the format test and fix ctrl+c error
  * Update depth alignment function to align with librealsense
    Update depth alignment function to align with librealsense since
    librealsense already upstreamed to ROS2/Crystal, also we can benifit from
    the future librealsense optimization.
  * fix ctrl+c error
  * pass the format test
  * Merge pull request #29 <https://github.com/intel/ros2_intel_realsense/issues/29> from ahuizxc/master
    fixed bug that camera not work when enable_depth=False
  * fixed bug that camera not work when enable_depth=False
  * Merge pull request #23 <https://github.com/intel/ros2_intel_realsense/issues/23> from intel/fix_ctest
    fix error when run CTest
  * fix error when run CTest
    * set Realsense device not exist by default, disable testapi when Realsense device not plugin
    * fix format error when run CTest
  * Merge pull request #22 <https://github.com/intel/ros2_intel_realsense/issues/22> from RachelRen05/update_readme
    update project to install debain package dependency
  * update readme.md
    * update project to install debain package dependency
    * add rviz default configuration and support ros2 launch
  * update maintainer
  * 2.0.3
  * update changelog
  * Merge pull request #18 <https://github.com/intel/ros2_intel_realsense/issues/18> from nuclearsandwich/add-dependencies-to-package.xml
    Add eigen as a build dependency for ros2debian
  * Add eigen as a build dependency.
  * Contributors: Chris Ye, Gary Liu, RachelRen05, Sharron LIU, Steven! Ragnarök, Xiaojun Huang, ahuizxc, challenzhou

 -- Sharron LIU <sharron.liu@intel.com>  Wed, 29 May 2019 16:00:00 -0000

ros-dashing-realsense-ros2-camera (2.0.3-2bionic) bionic; urgency=high

  * Merge pull request #18 <https://github.com/intel/ros2_intel_realsense/issues/18> from nuclearsandwich/add-dependencies-to-package.xml
    Add eigen as a build dependency for ros2debian
  * Add eigen as a build dependency.
  * Contributors: Chris Ye, Steven! Ragnarök

 -- Sharron LIU <sharron.liu@intel.com>  Mon, 10 Dec 2018 16:00:00 -0000

ros-dashing-realsense-ros2-camera (2.0.2-2bionic) bionic; urgency=high

  * Merge pull request #15 <https://github.com/intel/ros2_intel_realsense/issues/15> from intel/pointer_api
    create a Subscriber using a raw pointer
  * create a Subscriber using a raw pointer
    std::shared_ptr is not safe, replace with new pointer API from image_transport (https://github.com/ros-perception/image_common/pull/104)
    Signed-off-by: Chris Ye <chris.ye@intel.com>
  * Merge pull request #16 <https://github.com/intel/ros2_intel_realsense/issues/16> from intel/enable_realsense
    update librealsense dependence
  * update Readme to modify librealsense guide
  * added librealsense2 dependence
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * create wrapper class PipelineSyncer to work around librealsense 2.16 feature, removing operator() from class asynchronous_syncer
    merge from https://github.com/IntelRealSense/librealsense/commit/985f3b75539ec08a78db69c9f8f2505d3d0c2e40
    Fix no match for call to '(rs2::asynchronous_syncer) (rs2::frame)' issue: https://github.com/IntelRealSense/librealsense/issues/2314
    Signed-off-by: Chris Ye <chris.ye@intel.com>
  * Merge pull request #13 <https://github.com/intel/ros2_intel_realsense/issues/13> from yechun1/image_transport
    publish raw image by image_transport publisher
  * fix typo and add transport in Readme
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * publish raw image by image_transport publisher
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Merge pull request #14 <https://github.com/intel/ros2_intel_realsense/issues/14> from yechun1/fix_build_issue
    add semicolon after RCLCPP_WARN to fix build issue
  * add semicolon after RCLCPP_WARN to fix build issue
    Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Merge pull request #12 <https://github.com/intel/ros2_intel_realsense/issues/12> from sharronliu/master
    camera node: replaced RCUTILS with RCLCPP logger
  * camera node: replaced RCUTILS with RCLCPP logger
    Signed-off-by: Sharron LIU <mailto:sharron.liu@intel.com>
  * Merge pull request #11 <https://github.com/intel/ros2_intel_realsense/issues/11> from ahuizxc/aligned_depth
    enable aligned depth image


=== debian/control ===
Source: ros-dashing-realsense-ros2-camera
Section: misc
Priority: extra
Maintainer: Sharron LIU <sharron.liu@intel.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-dashing-ament-cmake, ros-dashing-ament-cmake-gtest, ros-dashing-ament-lint-auto, ros-dashing-ament-lint-common, ros-dashing-builtin-interfaces, ros-dashing-cv-bridge, ros-dashing-image-transport, ros-dashing-librealsense2, ros-dashing-rclcpp, ros-dashing-realsense-camera-msgs, ros-dashing-rmw-implementation, ros-dashing-rosidl-default-generators, ros-dashing-sensor-msgs, ros-dashing-std-msgs, ros-dashing-tf2-ros, ros-dashing-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-dashing-realsense-ros2-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-dashing-builtin-interfaces, ros-dashing-cv-bridge, ros-dashing-librealsense2, ros-dashing-rclcpp, ros-dashing-realsense-camera-msgs, ros-dashing-rmw-implementation, ros-dashing-rosidl-default-runtime, ros-dashing-sensor-msgs, ros-dashing-std-msgs, ros-dashing-tf2-ros, ros-dashing-ros-workspace
Description: The realsense_ros2_camera package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-realsense-ros2-camera//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
